;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Layer 3 Customizer 1.1, by imamelia
;
; This patch allows you to specify your own Layer 3 images and give them custom
; behavior and graphics on a per-level basis.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

lorom

;!Freespace = $B88000
;!Freespace2 = $BC8000

!LastSubmap = $0DDB	; used to figure out if necessary to flicker screen

; you may want to change this; see note in readme
!DecompressionBuffer = $7EAD00

;------------------------------------------------
; Layer 3 image/behavior stuff
;------------------------------------------------

org $009FB8				;
autoclean JML Layer3Init		; Layer 3 image initialization routine for levels
padbyte $FF : pad $00A06B	; fill the now-unused space with $FF

org $05BC3F				;
JML Layer3Main			; some code related to Layer 3 behavior

org $059000				;
padbyte $FF : pad $05A563	; fill more now-unused space with $FF

;------------------------------------------------
; Layer 3 ExGFX stuff
;------------------------------------------------

; store the sublevel number to free RAM
; (this is redundant if you're using LevelASM)
org $05D8B9
	JSR LevelNumMain

org $05DC46
LevelNumMain:
	LDA $0E
	STA $010B
	ASL
	RTS

org $009471
;LDX $13C6
;LDA #$18
JSL L3ExGFX_Label0
NOP

org $00A0B3
;JSR $810E
;JSR $8A79
JSL L3ExGFX_Label1
NOP
NOP

org $04859B
dl L3ExGFX_Label3

org $008229
;LDY $1DE8
;DEY
JSL S2SNMI

org $0FF780
JML L3ExGFX_HIJACK_STUFF
NOP

;------------------------------------------------
; custom code
;------------------------------------------------
freecode
prot Layer3Data
;------------------------------------------------

;------------------------------------------------
; Layer 3 image/behavior stuff
;------------------------------------------------

Layer3Init:
	PHP							;
	PHB							;
	PHK							;
	PLB							; change the data bank
	REP #$10						; 16-bit index because the level number is 16-bit
	LDX $010B					; level number into Y
	LDA.l Layer3Images,x			; load the Layer 3 image value for this level
	SEP #$10						; set Y (and X) back to 8-bit mode
	BEQ .End						; if this level has no Layer 3 image, skip the initialization process
	DEC							;
	JSR Layer3InitSub				;
.End								;
	PLB							;
	PLP							;
	JML $0080E7					; jump back to an RTS in bank 00

Layer3InitSub:
	REP #$30						; 16-bit AXY
	AND #$00FF					;
	ASL							;
	TAX							;
	ASL							;
	TAY							;
	LDA.l L3ImageVRAMStart,x		;
	STA $00						;
	TYX							;
	PHX							;
	LDA.l L3TilemapGFXFiles,x		;
	LDX $00						;
	JSL UploadGFXFile				;
	PLX							;
	LDA.l L3TilemapGFXFiles+2,x		;
	LDX #$5800					;
	JSL UploadGFXFile				;
	LDX $010B					;
	LDA.l Layer3Behaviors,x			;
	AND #$00FF					;
	BEQ .Return					;
	DEC							;
	STA $00						;
	LDA $00						;
	ASL							; times 3
	ADC $00						;
	TAX							; into Y
	LDA.l L3BehaviorInitPtrs,x		;
	STA $00						; set the lower 2 bytes of the 24-bit pointer to the Layer 3 initialization behavior data
	LDA.l L3BehaviorInitPtrs+2,x		;
	STA $02						; set the bank byte of the 24-bit pointer to the Layer 3 initialization behavior (garbage -> $03)
	SEP #$30						; 8-bit AXY
	PHK							;
	PEA.w .Return-1				; push a return address
	JML [$0000]					; and jump to the indirect address that was just set
.Return							;
	RTS							;

Layer3Main:
	PHP							;
	PHB							;
	PHK							;
	PLB							; change the data bank
	REP #$10						; 16-bit index because the level number is 16-bit
	LDX $010B					; level number into Y
	LDA.l Layer3Behaviors,x			; load the Layer 3 setting value for this level
	SEP #$10						; set Y (and X) back to 8-bit mode
	BEQ .End						; if this level has no Layer 3 image, skip the initialization process
	DEC							;
	JSR Layer3MainSub				;
.End								;
	PLB							;
	PLP
	JML $05BC47					; jump back to bank 05

Layer3MainSub:
	REP #$30						; 16-bit AXY
	AND #$00FF					;
	STA $00						; Layer 3 setting
	ASL							; times 3
	ADC $00						;
	TAX							; into Y
	LDA.l L3BehaviorMainPtrs,x		;
	STA $00						; set the lower 2 bytes of the 24-bit pointer to the Layer 3 initialization behavior data
	LDA.l L3BehaviorMainPtrs+2,x	;
	STA $02						; set the bank byte of the 24-bit pointer to the Layer 3 initialization behavior (garbage -> $03)
	SEP #$30						; 8-bit AXY
	PHK							;
	PEA.w .Return-1				; push a return address
	JML [$0000]					; and jump to the indirect address that was just set
.Return							;
	RTS							;

UploadGFXFile:
	PHY
	PHX
	CMP #$0032
	BCC .GFX00to31
	CMP #$0080
	BCC .UploadReturn
	CMP #$0100
	BCS .ExGFX100toFFF
.GFX80toFF
	AND #$007F
	STA $8A
	ASL
	CLC
	ADC $8A
	TAY
	LDA $0FF94F
	STA $06
	LDA $0FF950
	STA $07
	BRA .FinishDecomp
.UploadReturn
	PLX
	PLY
	RTL
.GFX00to31
	TAX
	LDA $00B992,x
	STA $8A
	LDA $00B9C4,x
	STA $8B
	LDA $00B9F6,x
	STA $8C
	BRA .FinishDecomp2
.ExGFX100toFFF
	SBC #$0100
	STA $8A
	ASL
	CLC
	ADC $8A
	TAY
	LDA $0FF873
	STA $06
	LDA $0FF874
	STA $07
.FinishDecomp
	LDA [$06],y
	STA $8A
	INC $06
	BNE .NoCrossBank
	SEP #$20
	INC $08
	REP #$20
.NoCrossBank
	LDA [$06],y
	STA $8B
.FinishDecomp2
	LDA.w #!DecompressionBuffer
	STA $00
	SEP #$20
	LDA.b #!DecompressionBuffer>>16
	STA $02
	PHK
	PEA .Ret1-1
	PEA $84CE
	JML $00B8DC
.Ret1
	REP #$10
	PLX
	STX $2116
	LDA #$01
	STA $4300
	LDA #$18
	STA $4301
	LDX.w #!DecompressionBuffer
	STX $4302
	LDA.b #!DecompressionBuffer>>16
	STA $4304
	LDX $8D
	STX $4305
	LDA #$01
	STA $420B
	REP #$20
	PLY
	RTL

;------------------------------------------------
; Layer 3 ExGFX stuff
;------------------------------------------------

L3ExGFX_HIJACK_STUFF:

	PHB
	PHX
	PHY		; Preserve nearly everything
	PHP
	PHK
	PLB

	LDA.w $0100	; don't execute if not loading level
	CMP.b #$04
	BEQ .InLevel
	CMP.b #$12
	BNE .NotInLevel

.InLevel
	JSR L3ExGFX_Label2	; run code

	SEP #$20
	LDA #$0F
	PHA
	PLB

.NotInLevel

	PLP
	PLY
	PLX
	PLB

	PEA $F783
	LDA #$0C
	JML $0FF840	; return

;-----------------------;
; OW Layer 3 ExGFX Rt   ;
;-----------------------;
; Submap -> Submap      ;
;-----------------------;

L3ExGFX_Label3:
SEP #$30			;original routine located at $04DAEF
LDA $1DE8
JSL $0086FA		;ExecutePtrLong   

dl $04DB18
dl $04DCB6
dl $04DCB6
dl $04DCB6
dl $04DCB6
dl ExGraFix		;FG1 1st half
dl L3ExGFX_Wait	;FG1 2nd half
dl ExGraFix		;FG2 1st half
dl L3ExGFX_Wait	;FG2 2nd half
dl ExGraFix		;FG3 1st half
dl L3ExGFX_Wait	;FG3 2nd half
dl ExGraFix		;FG4 1st half
dl L3ExGFX_Wait	;FG4 2nd half
dl ExGraFix		;L3-1
dl ExGraFix		;L3-2
dl ExGraFix		;L3-3
dl ExGraFix		;L3-4
dl $04DB9D
dl $04DB18
dl $04DBCF

ExGraFix:		;executes when $1DE8 equals $05-$10
INC $1DE8		;next submap-change mode
STZ $00			; \
LDA #$EC		;  | destination
STA $01			;  | of data
LDA #$7E		;  |
STA $02			; /
LDA $1DE8		;$06-$0D (because it was INC'd)
CMP #$0E		;if $0E-$11, then do layer 3 GFX
BCS Layer3S2S		;else stay and do FG1-FG4 ($06-$0D)
LDA $1DE8		; \ only upload GFX file once to RAM
AND #$01		;  |
BNE ReturnB04		; /
LDX $0DB3
LDA $1F11,x
ASL #3
CLC 
ADC $1DE8
SEC
SBC #$06
LSR A
TAX
LDA $00A96F,x		;get ExGFX file number
REP #$30
AND #$00FF
PHA
JSL $0FF900		;decompress
PLA
;CMP #$0008		;GFX08 gets special treatment...
;BEQ GFX08GFX1EFix
;CMP #$001E		;...so does GFX1E
;BEQ GFX08GFX1EFix
SEP #$30
ReturnB04:
JML $04DB9C		;a RTS in bank 04

Layer3S2S:
LDA $1DE8
CMP #$0E		;only make FBlank-or-not decision once
BNE ContinueL3S2S
LDX $0DB3
LDA $1F11,x
ASL #3
CLC
ADC !LastSubmap
TAX
LDA UseFBlankSubmap2Submap,x
BEQ NoFBlank
JMP UpdateL3WithFBlank
NoFBlank:
LDX $0DB3
LDA $1F11,x
STA !LastSubmap
ContinueL3S2S:
LDA $1DE8
SEC
SBC #$0E
ASL #3
LDX $0DB3
CLC
ADC $1F11,x
ASL A
TAX
REP #$30
LDA.l OWExGFX,x		;get ExGFX file number
JSL $0FF900		;decompress
SEP #$30
JML $04DB9C		;a RTS in bank 04

L3ExGFX_Wait:
INC $1DE8		;next submap-change mode
JML $04DB9C		;a RTS in bank 04

UpdateL3WithFBlank:
STZ $4200
STZ $420C
LDA #$80
STA $2100
JSL ReturnA
LDA #$81
STA $4200
LDA $1DE8
CLC
ADC #$03
STA $1DE8
JML $04DBD9

;-----------------------;
; Submap -> Submap NMI  ;
;-----------------------;

VRAMTable:		db $00,$04,$08,$0C,$10,$14,$18,$1C,$40,$44,$48,$4C
SrcTable:		db $EC,$F4,$EC,$F4,$EC,$F4,$EC,$F4,$EC,$EC,$EC,$EC

S2SNMI:
LDY $1DE8		;1st part of hijacked code
CPY #$06
BCC FinishS2S
CPY #$12
BCC S2SUpload

FinishS2S:
DEY			;2nd part of hijacked code
RTL

S2SUpload:
PHB
PHK
PLB
LDA #$80
STA $2115
STZ $2116
LDA VRAMTable-6,y
STA $2117
LDA #$01
STA $4320
LDA #$18
STA $4321
STZ $4322
LDA SrcTable-6,y
STA $4323
LDA #$7E
STA $4324
STZ $4325
LDA #$08
STA $4326
LDA #$04
STA $420B
PLB
LDY $1DE8		;1st part of hijacked code
BRA FinishS2S

;-------------------;
; Level -> Submap   ;
;-------------------;

L3ExGFX_Label1:
PHK
PER Return1-$01
PHB
LDA #$00
PHA
PLB
PEA $84CD
JML $008A79

Return1:
PHK
PER ReturnA-$01
PHB
LDA #$00
PHA
PLB
PEA $84CD
JML $00810E

ReturnA:
LDY $0DB3
LDA $1F11,y
STA !LastSubmap
JSR LoadNormalSlots
PHB
PHK
PLB
LDA #$FC
STA $03
LDA #$F0
STA $04

LoopUntilDone2:
LDA $04
CLC
ADC #$10
STA $04
LDA $03
CLC
ADC #$04
STA $03
LDY $0DB3
LDA $1F11,y
ASL A
CLC
ADC $04
TAX
REP #$30
LDA.l OWExGFX,x
LDX #$0000
JSR TheGeneralRoutine
SEP #$30
CMP #$30
BCC LoopUntilDone2
PLB
RTL

DMATable2:
db $01,$18,$00,$B9,$7E,$00,$08

;----------------------;
; General GFX Decomprs ;
;----------------------;

TheGeneralRoutine:
PHP
REP #$20
PHA
STZ $00
LDA #$7EB9
STA $01
PLA
CMP #$007F
BEQ UploadReturn
JSL $0FF900
SEP #$30
LDA #$80
STA $2115
LDA #$40
CLC
ADC $03,x
STA $2117
STZ $2116
LDX #$06

OWLoop:
LDA.l DMATable2,x
STA $4310,x
DEX
BPL OWLoop
LDA #$02
STA $420B
LDA $04

UploadReturn:
PLP
RTS

;------------;
; Credit Fix ;
;------------;

L3ExGFX_Label0:
JSR LoadNormalSlots
LDX $13C6
LDA #$18
RTL

;-----------------------;
; Level Layer 3 ExGFX   ;
;-----------------------;

L3ExGFX_Label2:
PHB                    ; Preserve DBR.
PHK                    ; \ PBR into DBR.
PLB                    ; /
LDA #$FC
STA $04
STZ $03

LoopUntilDone:
LDA $04
CLC
ADC #$04
STA $04
REP #$30
LDA $010B              ; \ Index level
ASL A
CLC
ADC $03
TAX
LDA.l Layer3ExGFX,x    ;  | Get GFX file from table.
LDX #$0001
JSR TheGeneralRoutine
SEP #$30
CMP #$0C
BCC LoopUntilDone
PLB
RTS

;-------------------;
; Load Normal Slots ;
;-------------------;

LoadNormalSlots:
LDA #$80
STA $2115
STZ $2116
LDA #$40
STA $2117
LDA #$03
STA $0F
LDA #$28
STA $0E

LoopGFX:
LDA $0E
TAX
LDA $00B992,x
STA $8A
LDA $00B9C4,x
STA $8B
LDA $00B9F6,x
STA $8C
STZ $00               ; \ Buffer = $7EB900
LDA #$B9	      ;  |
STA $01               ;  |
LDA #$7E              ;  |
STA $02               ; /
PHK
PER VRAMLoop-$01
PHB
PHY
JML $00BA47

VRAMLoop:
LDX #$06

DMALoopSoManieth:
LDA.l DMATable2,x
STA $4320,x
DEX
BPL DMALoopSoManieth
LDA #$04
STA $420B
INC $0E
DEC $0F
BPL LoopGFX
RTS

incsrc "layer3code.asm"

;------------------------------------------------
; 
;------------------------------------------------

;------------------------------------------------
; data tables and the like
;------------------------------------------------
freedata
;------------------------------------------------

Layer3Data:
incsrc "layer3data.asm"










